%define	name		Canna
%define	ver		3.5b2
%define	rel	 31

Summary: a Japanese input system named Canna
Name: %{name}
Version: %{ver}
Release: %{rel}
Copyright: Distributable
Group: Extensions/Japanese
URL: http://www.nec.co.jp/japanese/product/computer/soft/canna/

Source0: ftp://ftp.nec.co.jp/pub/Canna/Canna35/Canna35b2.tar.gz
Source1: rc.canna
Source2: Uum4.109.tar.gz
## Additional dictionary from http://www.coolbrain.net/shion.html
Source3: http://www.coolbrain.net/dl/shion/shion.tar.bz2
# NoSource: 0
# NoSource: 2
# NoSource: 3

Patch0: Canna-3.5b2.conf.patch
Patch1: Canna-3.5b2.Imakefile.patch
Patch2: Canna-3.5b2-glibc.patch
Patch3: Canna35b2-canuum.patch
Patch4: canuum-optarg.patch
Patch5: Canna35b2-unoff1.patch
Patch6: Canna35b2-unoff2.patch
Patch7: Canna35b2-hack1.patch
Patch8: Canna35b2-canuumfix.patch

Patch10: Canna-3.5b2-SetDicHome_fix.patch
Patch11: Canna-3.5b2-fhs.patch
Patch12: Canna-3.5b2-bcopy.patch
Patch13: Canna-3.5b2-multivul.patch
Patch14: Canna-3.5b2-wconv-ml.patch

Serial: 2002121501
Prefix: /usr
BuildRoot: /var/tmp/%{name}-%{version}-root
BuildRequires: XFree86

%description
Canna is a Japanese input system and provides a unified user interface
for inputting Japanese. It supports Nemacs(Mule), kinput2.
All of these tools can be used by a single customization file, romaji-to-kana
conversion rules and conversion dictionaries, and input Japanese in
the same way. It converts kana to kanji based on a client-server model and
supports automatic kana-to-kanji conversion.

%changelog
* Mon Dec 15 2002 TOMODA Shiori <stomoda@miraclelinux.com>
- added multivul patch
- added wconv patch

* Fri Feb  2 2001 Kazutomo Yoshii <kazutomo@turbolinux.co.jp>
- removed language from release

* Mon Jan 22 2001 Masaru Yokoi <masaru@turbolinux.co.jp>
- Changed shion dictionary to compiled dictionary. We need Canna-devel when compile it.

* Wed Dec 27 2000 Masaru Yokoi <masaru@turbolinux.co.jp>
- Added the dictionary shion.tar.gz to make Canna smart. (but not confiurated).
- Modified Imakefile patch to install all dictionary files with non-root users.

* Thu Dec 07 2000 Masaru Yokoi <masaru@turbolinux.co.jp>
- Added "BuildRequires: XFree86". Canna uses gccmakedep.

* Thu Oct 19 2000 Masaru Yokoi <masaru@turbolinux.co.jp>
- Fixed unoff1 patch (CVS Id tag is changed).
* Wed Aug  2 2000 SL Baur  <steve@turbolinux.co.jp>
- merge RedHat RawHide patches for alpha port

* Mon Jul 03 2000 Masaru Yokoi <masaru@turbolinux.co.jp>
- Added Canna-3.5b2-SetDicHome_fix.patch to fix vulnerability.

* Mon Jun 19 2000 Masaru Yokoi <masaru@turbolinux.co.jp>
- Changed if local distribution is TurboLinux WorkStation, execute cannaserver
  as default.
- Moved %postun scripts to %preun section.

* Thu May 11 2000 Masaru Yokoi <masaru@turbolinux.co.jp>
- change owner of /usr/sbin/cannaserver and /var/lib/canna/dic to bin,
  group to bin.

* Mon Apr 24 2000 Toshihiro Yamagishi<toshihiro@turbolinux.co.jp>
- do not execute in default

* Fri Feb 18 2000 Hirofumi Takeda <takepin@turbolinux.co.jp>
- canuum obsolated

* Wed Jan 26 2000 Hirofumi Takeda <takepin@turbolinux.co.jp>
- Repackaged for TurboLinux Workstation 6.0J

* Thu Dec 09 1999 KC M <kcm@turbolinux.co.jp>
- don't remove canna entry from services

* Thu Nov 18 1999 KC M <kcm@turbolinux.co.jp>
- change in1, in2 initialization (glibc patch)

* Tue Nov  9 1999 KC M <kcm@turbolinux.co.jp>
- add optarg patch

%package devel
Summary: files for developing programs that use Canna library
Group: Extensions/Japanese
Requires: Canna = %{PACKAGE_VERSION}-%{PACKAGE_RELEASE}
%description devel
This is a package for developing a program that use Canna API.


%prep
%setup -q -n Canna35b2 -a 3
%patch0 -p1 -b .conf
%patch1 -p1 -b .Imake
if [ -f /lib/libc-2* ]; then
%patch2 -p0 -b .glibc
fi
# set `/usr/bin/id`
# if [ X$1 != "Xuid=0(root)" ]; then
# %patch3 -p1 -b .canuum
# fi
%patch5 -p1 -b .unoff1
%patch6 -p1 -b .unoff2
%patch7 -p1 -b .hack1
%patch8 -p1 -b .canuumfix
%patch10 -p1 -b .SetDicHome_fix
%patch11 -p1 -b .fhs
%patch12 -p1 -b .bcopy
%patch13 -p1 -b .multivul
%patch14 -p1 -b .wconv

rm -fr $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/X11R6
if [ -d /usr/X11R6.1 ]; then
	ln -sf $RPM_BUILD_ROOT/usr/X11R6 $RPM_BUILD_ROOT/usr/X11R6.1
fi
if [ -d /usr/X11R6.3 ]; then
	ln -sf $RPM_BUILD_ROOT/usr/X11R6 $RPM_BUILD_ROOT/usr/X11R6.3
fi
mkdir -p $RPM_BUILD_ROOT/usr/X11R6/bin
mkdir -p $RPM_BUILD_ROOT/usr/X11R6/man/man1

cp Canna.conf Canna_conf.bak
sed 's/^ *JapaneseLocale *= *ja */JapaneseLocale = ja_JP.ujis/' < Canna_conf.bak > Canna.conf

cd canuum
tar zxf %{SOURCE2}
mv Uum4.109/* .
patch  < Canuum.patch
%patch4 -p2 -b .optarg

%build
xmkmf
make Makefile
make canna

cd canuum
xmkmf -a
make
cd ..

#%patch3 -p1
#(cd canuum; xmkmf -a; make)

## Make shion dic
#cd shion
#for i in ../cmd/* ; do buildPath=${buildPath}:${i} ; done
#PATH=${PATH}:${buildPath} make
#cd ..

%install
rm -rf $RPM_BUILD_ROOT
make DESTDIR=$RPM_BUILD_ROOT install
make DESTDIR=$RPM_BUILD_ROOT MANDIR=/usr/share/man install.man
mkdir -p $RPM_BUILD_ROOT/usr/share/man/ja_JP.ujis/man1
mkdir -p $RPM_BUILD_ROOT/usr/share/man/ja_JP.ujis/man3
(
  cd $RPM_BUILD_ROOT/usr/share/man/ja_JP.ujis
  if [ -d man1x ]; then
    mkdir -p man1
    mv man1x/* man1
  fi
  if [ -d man3x ]; then
    mkdir -p man3
    mv man3x/* man3
  fi
)
mv misc/manual.sed .
rm -fr misc
mkdir misc
mv manual.sed misc

mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
cp %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/canna

#cd canuum
#make DESTDIR=$RPM_BUILD_ROOT install

## install shion
cd shion
make install DESTDIR=$RPM_BUILD_ROOT

chmod u+w $RPM_BUILD_ROOT/var/lib/canna/dic/canna/dics.dir
cat <<__END__>> $RPM_BUILD_ROOT/var/lib/canna/dic/canna/dics.dir
basho.cbd(basho.mwd)		-basho---
kaom.cbd(kaom.mwd)		-kaom---
keisan.cbd(keisan.mwd)		-keisan---
pub.cbd(pub.mwd)		-pub---
scien.cbd(scien.mwd)		-scien---
sup.cbd(sup.mwd)		-sup---
pub.cld(pub.mwd)		-pub---
__END__
chmod u-w $RPM_BUILD_ROOT/var/lib/canna/dic/canna/dics.dir

%clean
rm -fr $RPM_BUILD_ROOT

%post
if [ -f /etc/turbolinux-release ] && \
	[ "`grep WorkStation /etc/turbolinux-release `" ] ; then
	/sbin/chkconfig --add canna
fi

#if ! grep -q canna /etc/services
#then
#        cp -p /etc/services /etc/services.orig
#	echo "canna		5680/tcp" >>/etc/services
#fi
#/etc/rc.d/init.d/canna start 

%preun
/sbin/chkconfig --del canna	
#/etc/rc.d/init.d/canna stop

#%postun
#if [ "$1" = 0 ]
#then
#        if grep -q canna /etc/services
#        then
#                cp -p /etc/services /etc/services.orig
#                sed '/^canna/d' /etc/services >/tmp/services.$$
#                mv /tmp/services.$$ /etc/services
#        fi
#fi

%post devel
/sbin/ldconfig

%postun devel
/sbin/ldconfig

%files
%defattr(-,root,root)
%doc CHANGES.jp INSTALL INSTALL.jp README README.jp WHATIS WHATIS.jp
%doc Canna.conf doc misc
%attr(0755,root,root) /etc/rc.d/init.d/canna
/var/lib/canna/default.canna
/var/lib/canna/engine.cf
/var/lib/canna/sample
/usr/bin/*
/usr/sbin/cannakill
/usr/lib/lib*.so.*
/usr/share/man/ja_JP.ujis/man1/*
%attr(-,bin,bin) /usr/sbin/cannaserver
%attr(-,bin,bin) /var/lib/canna/dic
%attr(-,bin,bin) /var/log/canna

%files devel
%defattr(-,root,root)
/usr/include/canna/
/usr/lib/lib*.a
/usr/lib/lib*.so
/usr/share/man/ja_JP.ujis/man3/*
